<?php
if ( ! class_exists( 'Beauty_Cosmetic_Shop_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Beauty_Cosmetic_Shop_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Beauty_Cosmetic_Shop_Plugin_Activation_WPElemento_Importer {

        private static $beauty_cosmetic_shop_instance;
        public $beauty_cosmetic_shop_action_count;
        public $beauty_cosmetic_shop_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$beauty_cosmetic_shop_instance) ) {
            self::$beauty_cosmetic_shop_instance = new self();
          }
          return self::$beauty_cosmetic_shop_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'beauty_cosmetic_shop_recommended_plugins', array($this, 'beauty_cosmetic_shop_recommended_elemento_importer_plugins_array') );

            $beauty_cosmetic_shop_actions                   = $this->beauty_cosmetic_shop_get_recommended_actions();
            $this->beauty_cosmetic_shop_action_count        = $beauty_cosmetic_shop_actions['count'];
            $this->beauty_cosmetic_shop_recommended_actions = $beauty_cosmetic_shop_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function beauty_cosmetic_shop_recommended_elemento_importer_plugins_array($beauty_cosmetic_shop_plugins){
            $beauty_cosmetic_shop_plugins[] = array(
                    'name'     => esc_html__('Mizan Demo Importor', 'beauty-cosmetic-shop'),
                    'slug'     =>  'mizan-demo-importer',
                    'function' => 'Mizan_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the Mizan Demo Importor plugin for importing the demo content with Elementor.', 'beauty-cosmetic-shop'),               
            );
            return $beauty_cosmetic_shop_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'beauty-cosmetic-shop-plugin-activation-script', esc_url(get_template_directory_uri()) . '/inc/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('beauty-cosmetic-shop-plugin-activation-script', 'beauty_cosmetic_shop_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'beauty-cosmetic-shop'),
                    'activating' => esc_html__('Activating', 'beauty-cosmetic-shop'),
                    'error' => esc_html__('Error', 'beauty-cosmetic-shop'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=mizan-demo-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=mizandemoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'beauty-cosmetic-shop-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function beauty_cosmetic_shop_get_recommended_actions() {

            $beauty_cosmetic_shop_act_count  = 0;
            $beauty_cosmetic_shop_actions_todo = get_option( 'recommending_actions', array());

            $beauty_cosmetic_shop_plugins = $this->beauty_cosmetic_shop_get_recommended_plugins();

            if ($beauty_cosmetic_shop_plugins) {
                foreach ($beauty_cosmetic_shop_plugins as $beauty_cosmetic_shop_key => $beauty_cosmetic_shop_plugin) {
                    $beauty_cosmetic_shop_action = array();
                    if (!isset($beauty_cosmetic_shop_plugin['slug'])) {
                        continue;
                    }

                    $beauty_cosmetic_shop_action['id']   = 'install_' . $beauty_cosmetic_shop_plugin['slug'];
                    $beauty_cosmetic_shop_action['desc'] = '';
                    if (isset($beauty_cosmetic_shop_plugin['desc'])) {
                        $beauty_cosmetic_shop_action['desc'] = $beauty_cosmetic_shop_plugin['desc'];
                    }

                    $beauty_cosmetic_shop_action['name'] = '';
                    if (isset($beauty_cosmetic_shop_plugin['name'])) {
                        $beauty_cosmetic_shop_action['title'] = $beauty_cosmetic_shop_plugin['name'];
                    }

                    $beauty_cosmetic_shop_link_and_is_done  = $this->beauty_cosmetic_shop_get_plugin_buttion($beauty_cosmetic_shop_plugin['slug'], $beauty_cosmetic_shop_plugin['name'], $beauty_cosmetic_shop_plugin['function']);
                    $beauty_cosmetic_shop_action['link']    = $beauty_cosmetic_shop_link_and_is_done['button'];
                    $beauty_cosmetic_shop_action['is_done'] = $beauty_cosmetic_shop_link_and_is_done['done'];
                    if (!$beauty_cosmetic_shop_action['is_done'] && (!isset($beauty_cosmetic_shop_actions_todo[$beauty_cosmetic_shop_action['id']]) || !$beauty_cosmetic_shop_actions_todo[$beauty_cosmetic_shop_action['id']])) {
                        $beauty_cosmetic_shop_act_count++;
                    }
                    $beauty_cosmetic_shop_recommended_actions[] = $beauty_cosmetic_shop_action;
                    $beauty_cosmetic_shop_actions_todo[]        = array('id' => $beauty_cosmetic_shop_action['id'], 'watch' => true);
                }
                return array('count' => $beauty_cosmetic_shop_act_count, 'actions' => $beauty_cosmetic_shop_recommended_actions);
            }

        }

        public function beauty_cosmetic_shop_get_recommended_plugins() {

            $beauty_cosmetic_shop_plugins = apply_filters('beauty_cosmetic_shop_recommended_plugins', array());
            return $beauty_cosmetic_shop_plugins;
        }

        public function beauty_cosmetic_shop_get_plugin_buttion($slug, $name, $function) {
                $beauty_cosmetic_shop_is_done      = false;
                $beauty_cosmetic_shop_button_html  = '';
                $beauty_cosmetic_shop_is_installed = $this->is_plugin_installed($slug);
                $beauty_cosmetic_shop_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $beauty_cosmetic_shop_is_activeted = (class_exists($function)) ? true : false;
                if (!$beauty_cosmetic_shop_is_installed) {
                    $beauty_cosmetic_shop_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $beauty_cosmetic_shop_plugin_install_url = wp_nonce_url($beauty_cosmetic_shop_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $beauty_cosmetic_shop_button_html        = sprintf('<a class="beauty-cosmetic-shop-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($beauty_cosmetic_shop_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'beauty-cosmetic-shop'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'beauty-cosmetic-shop')
                    );
                } elseif ($beauty_cosmetic_shop_is_installed && !$beauty_cosmetic_shop_is_activeted) {

                    $beauty_cosmetic_shop_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($beauty_cosmetic_shop_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $beauty_cosmetic_shop_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $beauty_cosmetic_shop_button_html = sprintf('<a class="beauty-cosmetic-shop-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($beauty_cosmetic_shop_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'beauty-cosmetic-shop'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'beauty-cosmetic-shop')
                    );
                } elseif ($beauty_cosmetic_shop_is_activeted) {
                    $beauty_cosmetic_shop_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'beauty-cosmetic-shop'));
                    $beauty_cosmetic_shop_is_done     = true;
                }

                return array('done' => $beauty_cosmetic_shop_is_done, 'button' => $beauty_cosmetic_shop_button_html);
            }
        public function is_plugin_installed($slug) {
            $beauty_cosmetic_shop_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $beauty_cosmetic_shop_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($beauty_cosmetic_shop_installed_plugins[$beauty_cosmetic_shop_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $beauty_cosmetic_shop_keys = array_keys($this->get_installed_plugins());
            foreach ($beauty_cosmetic_shop_keys as $beauty_cosmetic_shop_key) {
                if (preg_match('|^' . $slug . '/|', $beauty_cosmetic_shop_key)) {
                    return $beauty_cosmetic_shop_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Beauty_Cosmetic_Shop_Plugin_Activation_WPElemento_Importer::get_instance();